local myname="ZifnabsEmotor"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={emotor=Me} else ZifnabsMod.emotor=Me end
local fw
local mod
local C
local L
local db
local dbpc

local SOULSTONE_TIME=30*60
local PLAYERNAME=UnitName("player").." "..GetRealmName()
local reaction={precheck={}}
local summon
local state={infight=false,fishing=false}
local unknownspell={}
local widget={}
local last={}
local lastspell=nil
local config={}
local language={}
local relang={}

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	fw=fwinfo
	mod=fwinfo.mod
	C=fwinfo.C
	L=fwinfo.L
	db=fwinfo.db
	if (db.emotor and db.emotor.muted) or fwinfo.petname then												-- Umstellung auf DBPC
		fwinfo.dbpc.emotor={muted=db.emotor.muted,language=1,petname=mod.f:CopyTable(fwinfo.dbpc.petname)}	-- für Mute & Petname
		db.emotor.muted=nil																					-- mit
		fwinfo.dbpc.petname=nil																				-- r191031a
	end																										--
	if not fwinfo.dbpc.emotor then fwinfo.dbpc.emotor={muted=false,language=1} end
	dbpc=fwinfo.dbpc.emotor
	if not dbpc.button then dbpc.button={} end																-- neu mit r191117a
	if not db.emotor or not db.emotor.cmd.HI or type(db.emotor.cmd.HI.option.react)~="table" then db.emotor={cmd={},hesheit={},pet={}, nosexfound={}} end
	
	for cmd,data in pairs(L.emotor.cmd) do
		if not db.emotor.cmd[cmd] then
			db.emotor.cmd[cmd]=data
			mod.f:PrintR(L.msg.cmdinserted,{cmd=cmd})
		end
	end
	for key,data in pairs(L.emotor.hesheit) do
		if not db.emotor.hesheit[key] then
			db.emotor.hesheit[key]=data
			mod.f:PrintR(L.msg.hsiinserted,{key=key})
		end
	end
		
	widget.mute=mod.ui:newControlButton(2,myname.."_Mute",{click=Me.Mute})
	Me:Mute("set",dbpc.muted)
	language={[1]={lang=GetDefaultLanguage("player")}}
	for n=1,GetNumLanguages() do
		local lang,nr=GetLanguageByIndex(n)
		local lx=1+#language
		if lang==language[1].lang then lx=1 end
		language[lx]={lang=lang,id=nr}
		relang[nr]=lx
	end
	if GetNumLanguages()>1 then
		widget.language=mod.ui:newControlButton(4,myname.."_Language",{click=Me.Language})
		Me:Language(widget.language,nil)
	end
	Me:ShowButtons()
	
	mod.core:Register4Event("PLAYER_REGEN_DISABLED","emotor",Me.PLAYER_REGEN_DISABLED)
	mod.core:Register4Event("PLAYER_REGEN_ENABLED","emotor",Me.PLAYER_REGEN_ENABLED)
	mod.core:Register4Event("UNIT_SPELLCAST_START","emotor",Me.SPELLCAST_START)
	mod.core:Register4Event("UNIT_SPELLCAST_CHANNEL_START","emotor",Me.SPELLCAST_CHANNEL_START)
	mod.core:Register4Event("UNIT_SPELLCAST_CHANNEL_STOP","emotor",Me.SPELLCAST_CHANNEL_STOP)
	mod.core:Register4Event("UNIT_SPELLCAST_SUCCEEDED","emotor",Me.UNIT_SPELLCAST_SUCCEEDED)
	mod.core:Register4Event("ONUPDATE","emotor",Me.OnUpdate)

	BINDING_NAME_ZIFNABS_EMOTOR_HI    = L.keybind.emotor.hi
	BINDING_NAME_ZIFNABS_EMOTOR_BYE   = L.keybind.emotor.bye
	BINDING_NAME_ZIFNABS_EMOTOR_SORRY = L.keybind.emotor.sorry
	BINDING_NAME_ZIFNABS_EMOTOR_THANK = L.keybind.emotor.thank
	BINDING_NAME_ZIFNABS_EMOTOR_CHEER = L.keybind.emotor.cheer
	BINDING_NAME_ZIFNABS_EMOTOR_CRY   = L.keybind.emotor.cry  
	BINDING_NAME_ZIFNABS_EMOTOR_SIGH  = L.keybind.emotor.sigh
	BINDING_NAME_ZIFNABS_EMOTOR_WAVE  = L.keybind.emotor.wave
end

function Me:PostInit()
	for name,data in pairs(db.emotor.nosexfound) do
		if not Me:GetSex(name,"initcheck") then 
			if mod.targets.Seen(name) then mod.f:PrintR(L.msg.nosexfound,{target=name})
			else db.emotor.nosexfound[name]="nil" end -- offenbar ein "Falschläufer"
		else
			db.emotor.nosexfound[name]=nil
			mod.f:PrintR(L.msg.sexfound,{target=name})
		end
	end
	if #language>1 and AddOn_TotalRP3 and AddOn_TotalRP3.Language then
		widget.language:Hide()
		mod.f:Print(L.msg.totalrp3)
	end
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate()
	if language[dbpc.language] and language[dbpc.language].id~=ChatFrame1EditBox.languageID then
		if relang[ChatFrame1EditBox.languageID] then
			dbpc.language=relang[ChatFrame1EditBox.languageID]
			Me:Language(widget.language)
		end
	end
	local lclass,eclass,wtf=UnitClass("player")
	local petname=UnitName("pet")
	if summon then
		if UnitCreatureFamily("pet")==summon.family then
			if not dbpc.petname then dbpc.petname={} end
			dbpc.petname[summon.slot]=petname
			summon=nil
		elseif time()-summon.start>11 then
			summon=nil
		end
	elseif eclass=="HUNTER" and petname then
		dbpc.hunterpet=petname
	end
end

-- --------------------------------------------------------------------------------------
-- PLAYER REGEN ENABLED/DISABLED
-- --------------------------------------------------------------------------------------
function Me:PLAYER_REGEN_DISABLED() 
	state.infight=true
	if state.fishing then Me:Command(L.word.FISHING_ATTACKED) end
end
function Me:PLAYER_REGEN_ENABLED() state.infight=false end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_START
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_START(who,spellid,rank,more) Me:AnyCast(who,spellid,rank,"cast") end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_CHANNEL_START
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_START(who,spellid,rank,more) Me:AnyCast(who,spellid,rank,"channel") end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_CHANNEL_STOP
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_STOP(who,spellid,rank,more)
	local spell,srank,icon,casttime,minrange,maxrange=GetSpellInfo(rank)	
	if spell==L.word.FISHING then state.fishing=false end
end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_SUCCEEDED
-- --------------------------------------------------------------------------------------
function Me:UNIT_SPELLCAST_SUCCEEDED(who,spellid,rank) Me:AnyCast(who,spellid,rank,"succeed") end

-- --------------------------------------------------------------------------------------
-- ANY CAST
-- --------------------------------------------------------------------------------------
function Me:AnyCast(who,spellid,rank,casttype)
	if casttype=="succeed" and rank==lastspell then return end
	lastspell=rank
	local spell,srank,icon,casttime,minrange,maxrange=GetSpellInfo(rank)	
	local list=nil
	if who=="player" and spell and db.emotor.cmd[spell] then 
		-- Angeln
		if spell==L.word.FISHING then
			state.fishing=true
			local x,y,z,pos=mod.loc:GetLoc()
			if not reaction.precheck or not reaction.precheck.FISHING or mod.loc:Distance(pos,reaction.precheck.FISHING.loc)>0.5 or time()-reaction.precheck.FISHING.time>300 then spell=spell.." 1" end
			reaction.precheck.FISHING={time=time(),loc=pos}
		end
		-- Seelenstein setzen
		if spell==L.word.SET_SOULSTONE then
			mod.scheduler:add(SOULSTONE_TIME-60,"SSS-60","*.mod.hud:write(*.mod.f:Repl(*.L.msg.soulstonefade,{rest=60}),\"SOULSTONEOUT\")")
			list="SELF"
			for party=1,5,1 do
				if UnitName("party"..party) and UnitName("target")==UnitName("party"..party) then list="TARGET" end
			end
			for raid=1,40,1 do
				if UnitName("raid"..raid) and UnitName("target")==UnitName("raid"..raid) then list="TARGET" end
			end		
		end
		Me:Command(spell,nil,list,true)
	else
		if who=="player" and not unknownspell[spell] then unknownspell[spell]={rank=rank,casttype=casttype,spellid=spellid} end
		if who=="player" and db.emotor.debug and time()-(unknownspell[spell].last or 0)>180 then 
			mod.f:Debug(L.msg.unknownspell,{spell=spell,cast=(casttype or "")}) 
			unknownspell[spell].last=time()
		end
	end
end

-- --------------------------------------------------------------------------------------
-- COMMAND
-- --------------------------------------------------------------------------------------
function Me:Command(cmd,parm,list,iscasting)
	local ucmd=string.upper(cmd)
	local uparm=string.upper(parm or "")
		
	list=list or "NOTARGET"
	pet=pet or UnitName("pet") or ""
	local skipemotes=false
	
	-- Pet Aktion
	if ucmd=="PET" then
		if not UnitExists("pet") or string.upper(parm)=="PASSIVE" and not state.infight then
			cmd=nil
		else
			local lclass,class,dummy=UnitClass("player")
			if class=="WARLOCK" then 
				ucmd="DEMON" 
				-- TODO eventuell noch spezialisieren auf IMP/VOID/SUCCUBUS/FELHOUND
			end
			cmd=ucmd.."_"..string.upper(parm)
		end
	end

	if cmd and not db.emotor.cmd[cmd] and db.emotor.cmd[cmd.." "..(parm or "")] then cmd=cmd.." "..(parm or "")
	elseif not db.emotor.cmd[cmd] then cmd=ucmd end	
	-- lock out automatic cast reaction if same reaction has been requested via command <=1 second ago
	if iscasting and reaction.lastcall and reaction.lastcall[cmd] and time()-reaction.lastcall[cmd]<=1 then
		return
	elseif not iscasting then
		if not reaction.lastcall then reaction.lastcall={} end
		reaction.lastcall[cmd]=time()
	end
	
	if not cmd then nothing=nil
	elseif string.sub(cmd,1,1)=="/" then DoEmote(string.sub(cmd,2))
	elseif not db.emotor.cmd[cmd] then mod.f:PrintR(L.msg.unknowncmd,{cmd=cmd})
	elseif dbpc.muted and not db.emotor.cmd[cmd].unmutable then nothing=nil
	elseif not reaction[cmd] or time()-reaction[cmd].time>=(db.emotor.cmd[cmd].option.mute[PLAYERNAME] or db.emotor.cmd[cmd].option.mute.default) then
		if db.emotor.cmd[cmd].option.notarget then list="NOTARGET" end
		if not db.emotor.cmd[cmd].option.notarget and list=="NOTARGET" and UnitExists("target") and db.emotor.cmd[cmd].TARGET then
			list="TARGET"
			if (UnitCanAttack("player","target") or (UnitFactionGroup("target") and UnitFactionGroup("target")~=UnitFactionGroup("player"))) and db.emotor.cmd[cmd].ENEMY then list="ENEMY" end
			if list=="ENEMY" and cmd=="THANK" and (state.infight or UnitIsDead("target")) then 
				list="NOTARGET" 
				skipemotes=true
			end
			if UnitIsPlayer("target") then 
				local classify=mod.targets:Classify(UnitName("target"))
				if classify and db.emotor.cmd[cmd][classify] then list=classify end
			end
		end
		local selectedemo=""
		local selectedsay=""
		local react=db.emotor.cmd[cmd].option.react[PLAYERNAME] or db.emotor.cmd[cmd].option.react.default or 100
if FORCEEMOTOR then mod.f:Debug("Reaktion durch FORCEEMOTOR erzwungen") end		
		local rnd=math.random(99)
		if (rnd<react or FORCEEMOTOR) and db.emotor.cmd[cmd][list] then
-- TODO prevent empty list by redoing this block if necessary		
			local say=Me:Add2Selectable({},"say",db.emotor.cmd[cmd][list].say,cmd,list)
			local emo=Me:Add2Selectable({},"emo",db.emotor.cmd[cmd][list].emo,cmd,list,skipemotes)
			local chain=nil
			if db.emotor.cmd[cmd].option.chain then
				chain=mod.f:Split(db.emotor.cmd[cmd].option.chain,"[.]",2)
				if not chain[2] then chain[2]=list end
				if db.emotor.cmd[chain[1]] and db.emotor.cmd[chain[1]][chain[2]] then
					say=Me:Add2Selectable(say,"say",db.emotor.cmd[chain[1]][chain[2]].say,cmd,list)
					emo=Me:Add2Selectable(emo,"emo",db.emotor.cmd[chain[1]][chain[2]].emo,cmd,list,skipemotes)
				end
			end	

-- here is the "second chance block", not the best way to do it, but it works
			if #say==0 then
				say=Me:Add2Selectable({},"say",db.emotor.cmd[cmd][list].say,cmd,list)
				if chain and db.emotor.cmd[chain[1]] and db.emotor.cmd[chain[1]][chain[2]] then
					say=Me:Add2Selectable(say,"say",db.emotor.cmd[chain[1]][chain[2]].say,cmd,list)
				end
			end
			if #emo==0 then
				emo=Me:Add2Selectable({},"emo",db.emotor.cmd[cmd][list].emo,cmd,list,skipemotes)
				if chain and db.emotor.cmd[chain[1]] and db.emotor.cmd[chain[1]][chain[2]] then
					emo=Me:Add2Selectable(emo,"emo",db.emotor.cmd[chain[1]][chain[2]].emo,cmd,list,skipemotes)
				end
			end
	
			if #say>0 then 
				selectedsay=Me:TakeRandomFrom(say,"say."..cmd.."."..list) 
			elseif db.itsmemyself then 
				mod.f:PrintR(L.msg.emptylist,{list=cmd.."."..list..".say"}) 
			end
			if #emo>0 then 
				selectedemo=Me:TakeRandomFrom(emo,"emo."..cmd.."."..list) 
			elseif db.itsmemyself then 
				mod.f:PrintR(L.msg.emptylist,{list=cmd.."."..list..".emo"}) 
			end
			
			local concat=string.find(selectedsay,"&&")
			if concat then
				selectedemo=string.sub(selectedsay,concat+2)
				if concat>1 then selectedsay=string.sub(selectedsay,1,concat-1) else selectedsay="" end
			end
			selectedsay=Me:ReplaceKeysWithSex(selectedsay)
			selectedemo=Me:ReplaceKeysWithSex(selectedemo)			
			local repl={[".race"]=UnitRace("target") or UnitCreatureFamily("target") or UnitClass("target") or "Whatever"}
			repl.pet=UnitName("playerpet") or dbpc.hunterpet
			-- Dämon beschwören
			if db.emotor.cmd[cmd].option and db.emotor.cmd[cmd].option.summon then
				local demon=db.emotor.cmd[cmd].option.summon
				if L.word[demon] then 
					repl.pet=L.word[demon]
					summon={slot=demon,family=L.word[demon],start=time()}
					if dbpc.petname and dbpc.petname[demon] then repl.pet=dbpc.petname[demon] end					
				end
			end
			-- Magier Teleport / Portal
			if db.emotor.cmd[cmd].option and db.emotor.cmd[cmd].option.city then
				local parse=mod.f:Split(spell,":")
				if #parse==2 then repl.city=parse[2] end
			end
			for from,into in pairs(repl) do
				if selectedsay then selectedsay=mod.f:Repl(selectedsay,repl) end
				if selectedemo then selectedemo=mod.f:Repl(selectedemo,repl) end
			end			
			
			local channel="SAY"
			if strlower(strsub(selectedsay,1,3))=="/y " then
				selectedsay=strtrim(strsub(selectedsay,3))
				channel="YELL"
			end
			if selectedsay=="" then dummy=nil
			elseif iscasting and not FORCEEMOTOR then 
				if selectedemo and selectedemo~="" and string.sub(selectedemo,1,1)~="/" then
					selectedemo=selectedemo.." und sagt: \""..selectedsay.."\""
				else
					SendChatMessage("sagt: \""..selectedsay.."\"","EMOTE")
				end
			else 
				SendChatMessage(selectedsay,channel,language[dbpc.language or 1].id)
			end
			if string.sub(selectedemo,1,1)=="/" then DoEmote(string.sub(selectedemo,2)) else SendChatMessage(selectedemo,"EMOTE") end

			local x,y,z,pos=mod.loc:GetLoc()
			reaction[cmd]={time=time(),loc=pos}
		end
	end
end

function Me:TakeRandomFrom(tbl,lastid)
	local take=tbl[math.random(#tbl)].text
	if not take then 
		print("EMOTOR: TAKE=NIL for "..lastid.." ("..#tbl..")")
		take=""
	end
	if not last[lastid] then last[lastid]={} end
	last[lastid][take]=true
	return take
end

-- --------------------------------------------------------------------------------------
-- ADD TO TABLE
-- --------------------------------------------------------------------------------------
function Me:Add2Selectable(tbl,emosay,fromtbl,cmd,list,skipemotes)
	local lastid=emosay.."."..cmd.."."..list
	if not last[lastid] then last[lastid]={} end
	local excluded=0
	for nr,entry in pairs(fromtbl) do
		if (not entry.exclude or not entry.exclude[PLAYERNAME]) and (not entry.select or entry.select[PLAYERNAME]) then		
			if not last[lastid][entry.text] and (not skipemotes or string.sub(entry.text,1,1)~="/") then 
				tbl[1+#tbl]=entry  
			else 
				excluded=excluded+1
			end
		end
	end
	if #tbl<=1 then
		if excluded==0 or #tbl==0 then 
			last[lastid]={} 
		else 
			last[lastid]={[tbl[1].text]=true} 
		end
	end
	return tbl
end

-- --------------------------------------------------------------------------------------
-- REPLACE KEYS WITH SEX
-- --------------------------------------------------------------------------------------
function Me:ReplaceKeysWithSex(text)
	local playersex=UnitSex("player")	
	local targetsex=playersex
	local targetname=playername
	local cursorsex=playersex
	local cursorname=playername
	-- Geschlecht des Targets ermitteln
	if UnitExists("target") then 
		targetname=UnitName("target")
		targetsex=UnitSex("target") 
		if targetsex==1 then targetsex=Me:GetSex(targetname,"target") end -- sächlich, ist default für alle Kreaturen
		targetname=Me:Peal(targetname,"target")
	end
	
	-- Geschlecht des Cursorziels ermitteln
	cursorname=getglobal("GameTooltipTextLeft1"):GetText()
	if cursorname==nil then 
		cursorname=targetname 
		cursorsex=targetsex
	else
		cursorsex=Me:GetSex(cursorname)
		cursorname=Me:Peal(cursorname,"cursor")
	end

	-- Namen im Text ersetzen
	text=(text or "")
	text=mod.f:Repl(text,{["*"]=playername,["."]=targetname,["#"]=cursorname})

	-- Schlüsselworte im Text ersetzen
	for key,repl in pairs(db.emotor.hesheit) do
		text=mod.f:Repl(text,{["*"..key]=repl[playersex],["."..key]=repl[targetsex],["#"..key]=repl[cursorsex]})
		local ukey=string.upper(string.sub(key,1,1))..string.sub(key,2)
		local urep=string.upper(string.sub(repl[cursorsex],1,1))..string.sub(repl[cursorsex],2)
		text=mod.f:Repl(text,{["*"..ukey]=urep,["."..ukey]=urep,["#"..ukey]=urepl})
	end
	return text
end

-- --------------------------------------------------------------------------------------
-- GET SEX
-- --------------------------------------------------------------------------------------
function Me:GetSex(target,sexparm)
	local sex=1 -- Default ist sächlich
	local found=nil
	local word1,word2=strsplit(" ",strlower(target),2)
	if UnitName("pet")==target then
		sex=2 -- Pets sind normalerweise männlich, außer Sukkubus
		if UnitCreatureFamily("pet")==L.word.SUCCUBUS then sex=3 end
		found=true
	end
	
	if db.targets.list[target] and db.targets.list[target].player and db.targets.list[target].sex then
		sex=db.targets.list[target].sex
		found=true
	end
	
	-- vorangestellte Worte durchsuchen (z.B. Drache der ..., Akolyth der...)
	if word2 and not found then
		local search=L.emotor.sexprefix
		for i=1,#search,1 do
			if strfind(word1,search[i][2])==1 and not found then
				found="yes"
				sex=search[i][1]
			end
		end
		search=L.emotor.sexsufix
		for i=1,#search,1 do
			if strsub(word1,strlen(word1)-strlen(search[i][2])+1)==search[i][2] and not found then
				found="yes"
				sex=search[i][1]
			end
		end
	end
	
	-- Wortendungen durchsuchen
	word2=strlower(target)
	search=L.emotor.sexsufix
	for i=1,#search,1 do
		if strsub(word2,strlen(word2)-strlen(search[i][2])+1)==search[i][2] and not found then
			found="yes"
			sex=search[i][1]
		end
	end
	
	-- Letzte Wahl: Wenn es um "target" geht und das nicht als sächlich gekennzeichnet ist, DAS übernehmen
	if not found and sexparm=="target" and UnitSex("target")~=1 then
		sex=UnitSex("target") 
		found=sex
	end
	
	if not found then
		if db.itsmemyself and not db.emotor.nosexfound[target] then mod.f:PrintR(L.msg.nosexfound,{target=target}) end
		if sexparm~="initcheck" then 
			if not db.emotor.nosexfound[target] then db.emotor.nosexfound[target]={last=time(),count=1} end
			db.emotor.nosexfound[target]={last=time(),count=1+(db.emotor.nosexfound[target].count or 1)}
		end
	else
		if sexparm=="initcheck" then db.emotor.nosexfound[target]=nil end
	end
	if sexparm=="initcheck" then sex=found end
	return sex
end

-- --------------------------------------------------------------------------------------
-- PEAL
-- --------------------------------------------------------------------------------------
function Me:Peal(name,target)
	if target then
		local word=mod.f:Split(name," ",4)
		if #word==4 then 
			name=word[2]
			if string.len(name)<4 then name=word[1] end
		elseif #word==3 then name=word[1]
		elseif #word==2 then
			if UnitCanAttack("target","player") or target=="cursor" then name=word[2] end
		end
	end
	if target=="cursor" then
	-- Suffix entfernen ("vorkommen", "pflanze", "ader"...)
		local erase=L.emotor.erasesufix
		for i=1,#erase,1 do
			if strsub(name,strlen(name)-strlen(erase[i])+1)==erase[i] then
				name=strsub(name,1,strlen(name)-strlen(erase[i]))
			end
		end
	end
	return name
end

-- --------------------------------------------------------------------------------------
-- MUTE
-- --------------------------------------------------------------------------------------
function Me:Mute(set,tovalue)
	local iconname="Interface/AddOns/Zifnabs/Icons/Buttons/"
	if set~="set" then tovalue=(not dbpc.muted) end
	dbpc.muted=tovalue
	if tovalue then 
		iconname=iconname.."muted.tga" 
		widget.mute.tooltipText=L.msg.muted
	else 
		iconname=iconname.."unmuted.tga" 
		widget.mute.tooltipText=L.msg.unmuted
	end
	widget.mute:SetNormalTexture(iconname)
end

-- --------------------------------------------------------------------------------------
-- LANGUAGE
-- --------------------------------------------------------------------------------------
function Me:Language(button,parse)
	if parse then
		dbpc.language=1+(dbpc.language or 1)
		if dbpc.language>#language then dbpc.language=1 end
	end
	if button then 
		button.tooltipText=language[dbpc.language].lang
		local caption="*"
		if dbpc.language~=1 then caption=string.lower(string.sub(language[dbpc.language].lang,1,1)) end
		button:SetText(caption)
	end
	ChatFrame1EditBox.languageID=language[dbpc.language].id
end

-- --------------------------------------------------------------------------------------
-- SHOW ACTION BUTTONS
-- --------------------------------------------------------------------------------------
function Me:ShowButtons()
	if not widget.button then widget.button={} end
	for buttonname,button in pairs(widget.button) do button:Hide() end
	for cmd,show in pairs(dbpc.button) do
		if show.show then
			local buttonname=myname.."_"..UnitName("player").."_"..GetRealmName().."_"..cmd
			if not widget.button[buttonname] then
				widget.button[buttonname]=mod.ui:newFrame(buttonname.."_Frame",90,24,UIParent,"BOTTOMLEFT","BOTTOMLEFT",0,0,{transparent=true})
				local desc=db.emotor.cmd[cmd].option.desc or cmd
				widget.button[buttonname].button=mod.ui:newButton(buttonname.."_Button",90,20,widget.button[buttonname],"BOTTOM","BOTTOM",0,0,{text=desc,click=Me.ButtonAction})
				widget.button[buttonname].button.cmd=show.cmd
			end
			widget.button[buttonname]:Show()
		end
	end
end
function Me:ButtonAction(button,parse)
	Me:Command(button.cmd)
end
-- --------------------------------------------------------------------------------------
-- --------------------------------------------------------------------------------------

-- --------------------------------------------------------------------------------------
-- IDENTIFY CONFIG FRAMES
-- --------------------------------------------------------------------------------------
function Me:IdentifyConfigs() return {[1]=L.config.emotor,[2]=L.config.emotorkeys} end

function Me:CreateList(button)
	if button.cmd=="ask" then
		if mod.core:HandleChanges() then
			if not widget.askframe then
				local pframe,fx,fy=mod.core:GetParentConfigFrame()
				widget.cparent=pframe
				widget.askframe=mod.ui:newFrame(myname.."_CFrame_Emotor_AskNew",600,484,widget.cparent,"TOPLEFT","TOPLEFT",fx,fy,{hide=true,inherit="ZifnabsFrame",resetloc=true})
				widget.asknamet=mod.ui:addText(myname.."_CFrame_Emotor_AskName_Title",120,20,widget.askframe,"TOPLEFT","TOPLEFT",10,-40,12,"LEFT","TOP")
				widget.asknamet:SetText(L.msg.askname)
				widget.askname=mod.ui:newEditBox(myname.."_CFrame_Emotor_AskName",450,18,widget.askframe,"TOPLEFT","TOPLEFT",120,-40,{})
				widget.askdesct=mod.ui:addText(myname.."_CFrame_Emotor_AskDesc_Title",120,20,widget.askframe,"TOPLEFT","TOPLEFT",10,-60,12,"LEFT","TOP")
				widget.askdesct:SetText(L.msg.askdesc)
				widget.askdesc=mod.ui:newEditBox(myname.."_CFrame_Emotor_AskDesc",450,18,widget.askframe,"TOPLEFT","TOPLEFT",120,-60,{})
				widget.asktgtmode=mod.ui:newCheck(myname.."_CFrame_Emotor_TgtMode",20,20,widget.askframe,"TOPLEFT","TOPLEFT",10,-80,{click=nil,text=L.msg.targetmodeL,tt=L.msg.targetmodeLtt})
				widget.askok=mod.ui:newButton(myname.."_CFrame_Emotor_AskOk",80,20,widget.askframe,"TOPLEFT","TOPLEFT",10,-120,{click=Me.CreateList,text="Ok"})
				widget.askok.cmd="ok"
				widget.askabort=mod.ui:newButton(myname.."_CFrame_Emotor_AskAbort",80,20,widget.askframe,"TOPLEFT","TOPLEFT",100,-120,{click=Me.CreateList,text=L.msg.abort})
				widget.askabort.cmd="abort"
				widget.askhelp=mod.ui:addText(myname.."_CFrame_Emotor_AskHelp",450,100,widget.askframe,"TOPLEFT","TOPLEFT",10,-140,12,"LEFT","TOP")
				widget.askhelp:SetText(L.msg.askhelp)
			end
			widget.cparent:Hide()
			widget.cframe:Hide()
			widget.askframe:Show()
		end
	elseif button.cmd=="ok" then
		local action=mod.f:Trim(widget.askname:GetText())
		local usable=(action and action~="")
		local msg=L.msg.nameempty
		if usable and db.emotor.cmd[action] then 
			usable=false 
			msg=L.msg.nameduplicate
		end
		if not usable then
			mod.hud:write(msg,"Buzzer.mp3")
		else
			widget.askframe:Hide()
			widget.cparent:Show()
			widget.cframe:Show()
			local descriptive=widget.askdesc:GetText()
			local targetmode=widget.asktgtmode:GetChecked()
			order=-1
			for cmd,list in pairs(db.emotor.cmd) do
				if list.option.order<=order then order=list.option.order-1 end
			end
			db.emotor.cmd[action]={NOTARGET={emo={},say={}},option={order=order,react={default=100},mute={default=0},desc=descriptive}}
			if targetmode then
				db.emotor.cmd[action].TARGET={emo={},say={}}
				db.emotor.cmd[action].KNOWN={emo={},say={}}
				db.emotor.cmd[action].PAL={emo={},say={}}
				db.emotor.cmd[action].ENEMY={emo={},say={}}
			end
			Me:StartConfigActions()
		end
	else -- if cmd="Abort"
		widget.askframe:Hide()
		widget.cparent:Show()
		widget.cframe:Show()
	end
end

function Me:DeleteList(button)
	local list=config.cmds[config.selected.cmd].cmd
	config.cmds[config.selected.cmd].delete=true
	Me:InputChanged()
	Me:ShowSelection()
end

function Me:TargetMode(button)
	if mod.core:HandleChanges() then
		local list=config.cmds[config.selected.cmd].cmd
		local sublist=nil
		if config.cmds[config.selected.cmd].list.option.notarget or not config.cmds[config.selected.cmd].list.TARGET then
			config.cmds[config.selected.cmd].list.option.notarget=nil
			local tgtlist={["TARGET"]=1,["KNOWN"]=1,["PAL"]=1,["ENEMY"]=1}
			for tgt,futureuse in pairs(tgtlist) do
				if not config.cmds[config.selected.cmd].list[tgt] then
					config.cmds[config.selected.cmd].list[tgt]={emo={},say={}}
				end
			end
		else
			config.cmds[config.selected.cmd].list.option.notarget=true
			if config.selected.tgt~="NOTARGET" then sublist="NOTARGET" end
		end
		Me:InputChanged()
		Me:ShowSelection(nil,sublist,nil)
	end
end

-- --------------------------------------------------------------------------------------
-- START CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	widget.cframe=frame
	if not config then config={} end
	if config.snr~=frame.section.snr then config.top=nil end -- indicates frame change
	config.snr=frame.section.snr
	config.changed=false
	if config.snr==1 then Me:StartConfigActions(frame)
	elseif config.snr==2 then Me:StartConfigKeys(frame)
	end
end
function Me:StartConfigActions(frame)
--	db.emotor.cmd[cmd]={option={order=1,react={},mute={},desc="Gruß",summon=IMP|VOID...,chain=SUMMON_DEMON},["NOTARGET"]={say={{text=""}}}}
	if frame and not widget.cactions then
		widget.cactions={cmd={},tgt={},text={},tselmode={},tselect={}}
		-- Command Buttons
		for y=1,5,1 do for x=1,3,1 do
			local nr=3*y+x-3
			widget.cactions.cmd[nr]=mod.ui:newButton(myname.."_Cmd_"..nr,180,20,frame,"TOPLEFT","TOPLEFT",190*x-180,10-20*y,{click=Me.ButtonSelectCmd})
			widget.cactions.cmd[nr].selection=nr
		end end
		widget.cactions.cmdup=mod.ui:newButton(myname.."_CmdUp",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-10,{click=Me.ScrollUpCmds,text="^"})
		widget.cactions.cmddown=mod.ui:newButton(myname.."_CmdDown",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-90,{click=Me.ScrollDownCmds,text="v"})
		widget.cactions.react=mod.ui:newSlider(myname.."_Opt_React",200,20,frame,"TOPLEFT","TOPLEFT",10,-125,{min=0,max=100,val=0,text=L.word.percentreact,click=Me.InputChanged,tt=L.msg.ttreact})
		widget.cactions.mute=mod.ui:newSlider(myname.."_Opt_Mute",200,20,frame,"TOPLEFT","TOPLEFT",240,-125,{min=0,max=600,val=0,text=L.word.mute,click=Me.InputChanged,tt=L.msg.ttmute})
		widget.cactions.showbutton=mod.ui:newCheck(myname.."_ShowButton",20,20,frame,"TOPLEFT","TOPLEFT",475,-115,{click=Me.ButtonShowChange,text=L.msg.showbutton,tt=L.msg.showbuttontt})
		widget.cactions.delbutton=mod.ui:newButton(myname.."_DeleteList",100,20,frame,"TOPLEFT","TOPLEFT",475,-135,{click=Me.DeleteList,text=L.msg.deletelist,tt=L.msg.deletelisttt})
		widget.cactions.newbutton=mod.ui:newButton(myname.."_CreateList",100,20,frame,"TOPLEFT","TOPLEFT",475,-155,{click=Me.CreateList,text=L.msg.createlist,tt=L.msg.createlisttt})
		widget.cactions.newbutton.cmd="ask"
		widget.cactions.tgtbutton=mod.ui:newButton(myname.."_TargetMode",100,20,frame,"TOPLEFT","TOPLEFT",475,-180,{click=Me.TargetMode,text=L.msg.targetmode,tt=L.msg.targetmodett})
		widget.cactions.listname=mod.ui:addText(myname.."_Listname",300,10,frame,"TOPLEFT","TOPLEFT",10,-160,10,"LEFT")
		-- Target Buttons
		local word={[1]="NOTARGET",[2]="TARGET",[3]="KNOWN",[4]="PAL",[5]="ENEMY"}
		for t=1,5,1 do
			widget.cactions.tgt[t]=mod.ui:newButton(myname.."_Tgt_"..t,80,20,frame,"TOPLEFT","TOPLEFT",90*t-80,-180,{click=Me.ButtonSelectTarget,text=(L.word[word[t]] or word[t])})
			widget.cactions.tgt[t].selection={nr=t,target=word[t]}
		end
		-- Say & Emote
		widget.cactions.say=mod.ui:newButton(myname.."_Say",80,20,frame,"TOPLEFT","TOPLEFT",10,-205,{click=Me.ButtonSelectEmoSay,text=L.word.SAY})
		widget.cactions.say.selection="say"
		widget.cactions.emo=mod.ui:newButton(myname.."_Emo",80,20,frame,"TOPLEFT","TOPLEFT",100,-205,{click=Me.ButtonSelectEmoSay,text=L.word.EMO})
		widget.cactions.emo.selection="emo"
		-- Texte
		for t=1,12,1 do
			widget.cactions.text[t]=mod.ui:newEditBox(myname.."_Text_"..t,500,18,frame,"TOPLEFT","TOPLEFT",60,-210-20*t,{onchange=Me.InputChanged})
			widget.cactions.text[t].selection=t
			widget.cactions.tselect[t]=mod.ui:newCheck(myname.."_Text_Select_"..t,20,20,frame,"TOPLEFT","TOPLEFT",30,-210-20*t,{click=Me.ButtonSelectText})
			widget.cactions.tselect[t].selection=t
			widget.cactions.tselmode[t]=mod.ui:newButton(myname.."_Text_Mode_"..t,20,20,frame,"TOPLEFT","TOPLEFT",10,-210-20*t,{click=Me.ButtonSelectTextMode})
			widget.cactions.tselmode[t].selection=t
		end
		widget.cactions.txtup=mod.ui:newButton(myname.."_TxtUp",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-230,{click=Me.ScrollUpTexts,text="^"})
		widget.cactions.txtdown=mod.ui:newButton(myname.."_TxtDown",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-450,{click=Me.ScrollDownTexts,text="v"})
	end
	local temp={low=0,hi=0}
	config.button={}
	for cmd,list in pairs(db.emotor.cmd) do 
		temp[list.option.order]={cmd=cmd,list=mod.f:CopyTable(list),original=mod.f:CopyTable(list)} 
		temp.low=math.min(temp.low,list.option.order)
		temp.hi=math.max(temp.hi,list.option.order)
		config.button[cmd]=mod.f:CopyTable(dbpc.button[cmd])
	end
	config.cmds={}
	for nr=temp.low,temp.hi,1 do
		if temp[nr] then config.cmds[1+#config.cmds]={cmd=temp[nr].cmd,list=temp[nr].list,original=temp[nr].original} end
	end
	if not config.top or not frame then
		config.top={cmd=1,txt=1}
		config.selected={cmd=1,tgt="NOTARGET",es="say"}
	end
	Me:ShowSelection()
end
function Me:StartConfigKeys(frame)
--	db.emotor.hesheit[key]={"dieses","dieser","diese"}
	if not widget.ckeys then
		widget.ckeys={key={},he={},she={},it={}}
		widget.ckeys.up=mod.ui:newButton(myname.."_Up",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-10,{click=Me.ScrollUpKeys,text="^"})
		widget.ckeys.down=mod.ui:newButton(myname.."_Down",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-390,{click=Me.ScrollDownKeys,text="v"})
		for n=1,20,1 do
			widget.ckeys.key[n]=mod.ui:newEditBox(myname.."_Key_"..n,90,20,frame,"TOPLEFT","TOPLEFT",10,10-20*n,{onchange=Me.InputChanged})
			widget.ckeys.he[n]=mod.ui:newEditBox(myname.."_He_"..n,90,20,frame,"TOPLEFT","TOPLEFT",110,10-20*n,{onchange=Me.InputChanged})
			widget.ckeys.she[n]=mod.ui:newEditBox(myname.."_She_"..n,90,20,frame,"TOPLEFT","TOPLEFT",210,10-20*n,{onchange=Me.InputChanged})
			widget.ckeys.it[n]=mod.ui:newEditBox(myname.."_It_"..n,90,20,frame,"TOPLEFT","TOPLEFT",310,10-20*n,{onchange=Me.InputChanged})
		end
	end
	config.keys={}
	for key,list in pairs(db.emotor.hesheit) do config.keys[1+#config.keys]={key=key,list={list[1],list[2],list[3]},originalkey=key,originallist=list} end
	if not config.top then config.top=1 end
	Me:ScrollKeys(0)
end

function Me:ButtonSelectCmd(button) 
	local tgt=config.selected.tgt
	if not config.cmds[button.selection+config.top.cmd-1] then
		-- TODO neuer Command
	end
	if not config.cmds[button.selection+config.top.cmd-1].list[tgt] then
		if config.cmds[button.selection+config.top.cmd-1].list["NOTARGET"] then tgt="NOTARGET" else tgt="TARGET" end
	end
	Me:ShowSelection(button.selection,tgt,nil) 
end
function Me:ButtonSelectTarget(button) Me:ShowSelection(nil,button.selection.target,nil) end
function Me:ButtonSelectEmoSay(button) Me:ShowSelection(nil,nil,button.selection) end
function Me:ScrollUpCmds() Me:ShowSelection(nil,nil,nil,-3) end
function Me:ScrollDownCmds() Me:ShowSelection(nil,nil,nil,3) end
function Me:ScrollUpTexts() Me:ShowSelection(nil,nil,nil,nil,-1) end
function Me:ScrollDownTexts() Me:ShowSelection(nil,nil,nil,nil,1) end
function Me:ButtonSelectTextMode(button)
	local nr=config.top.txt+button.selection-1
	local entry=config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]
	-- switch from select to exclude mode
	if entry.select then
		if not entry.select[PLAYERNAME] then
			entry.exclude={[PLAYERNAME]=true}
		end
		entry.select=nil
		button:SetText("x")
	-- switch from exclude to select mode
	else
		entry.select={}
		if not entry.exclude or not entry.exclude[PLAYERNAME] then
			entry.select={[PLAYERNAME]=true}
		end
		entry.exclude=nil
		button:SetText("s")
	end
	Me:InputChanged()
end
function Me:ButtonSelectText(button) 
	local nr=config.top.txt+button.selection-1
	local entry=config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]
	if entry.select then entry.select[PLAYERNAME]=button:GetChecked()
	else
		if not entry.exclude then entry.exclude={} end
		entry.exclude[PLAYERNAME]=(not button:GetChecked())
	end
	Me:InputChanged()
end

-- --------------------------------------------------------------------------------------
-- SHOW EMOTOR SELECTION
-- --------------------------------------------------------------------------------------
function Me:ShowSelection(scmd,stgt,es,cmdscroll,txtscroll)
	config.setup=false
	if scmd or stgt or ed then
		config.setup=mod.core:HandleChanges()
		if not config.setup then
			scmd=nil
			stgt=nil
			es=nil
		end
	end
	if scmd then config.selected.cmd=scmd+config.top.cmd-1 end
	if stgt then config.selected.tgt=stgt end
	if es then config.selected.es=es end
	config.top.cmd=math.max(1,config.top.cmd+(cmdscroll or 0))
	if config.top.cmd==1 then widget.cactions.cmdup:Disable() else widget.cactions.cmdup:Enable() end
	if config.top.cmd+14>#config.cmds then widget.cactions.cmddown:Disable() else widget.cactions.cmddown:Enable() end
	config.top.txt=math.max(1,config.top.txt+(txtscroll or 0))
	if config.top.txt==1 then widget.cactions.txtup:Disable() else widget.cactions.txtup:Enable() end
	if config.top.txt+12>#config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es] then widget.cactions.txtdown:Disable() else widget.cactions.txtdown:Enable() end

	-- Command buttons
	for b=1,15,1 do
		local nr=b+config.top.cmd-1
		if nr>#config.cmds then widget.cactions.cmd[b]:Hide()
		else
			widget.cactions.cmd[b]:SetText(config.cmds[nr].list.option.desc or config.cmds[nr].cmd)
			widget.cactions.cmd[b]:Show()
			if nr==config.selected.cmd then widget.cactions.cmd[b]:Disable() else widget.cactions.cmd[b]:Enable() end
		end
	end
	-- Target Buttons
	local data=config.cmds[config.selected.cmd].list
	for t=1,5,1 do
		local target=widget.cactions.tgt[t].selection.target
		if target==config.selected.tgt then widget.cactions.tgt[t]:Disable() else widget.cactions.tgt[t]:Enable() end
		if data[target] and (target=="NOTARGET" or not data.option.notarget) then 
			widget.cactions.tgt[t]:Show() 
		else 
			widget.cactions.tgt[t]:Hide() 
		end
	end
	-- Say und Emote
	widget.cactions.say:Show()
	widget.cactions.emo:Show()
	if config.selected.es=="say" then widget.cactions.say:Disable() else widget.cactions.say:Enable() end
	if config.selected.es=="emo" then widget.cactions.emo:Disable() else widget.cactions.emo:Enable() end
	-- Options
	widget.cactions.listname:SetText(mod.f:Color("Listenname:"..config.cmds[config.selected.cmd].cmd,"909090"))
	-- Texte
	for t=1,12,1 do
		local text=""
		local mode="x"
		local sel=false
		if data[config.selected.tgt] and data[config.selected.tgt][config.selected.es][t+config.top.txt-1] then 
			local entry=data[config.selected.tgt][config.selected.es][t+config.top.txt-1]
			text=entry.text
			if entry.select then mode="s" end
			if (not entry.exclude or not entry.exclude[PLAYERNAME]) and (not entry.select or entry.select[PLAYERNAME]) then sel=true end
		end
		widget.cactions.text[t]:SetText(text)
		widget.cactions.tselmode[t]:SetText(mode)
		widget.cactions.tselmode[t].tooltipText=L.msg["tselmode"..mode]
		widget.cactions.tselect[t]:SetChecked(sel)
	end
	widget.cactions.react:SetValue(data.option.react[PLAYERNAME] or data.option.react.default or 100)
	widget.cactions.mute:SetValue(data.option.mute[PLAYERNAME] or data.option.mute.default or 0)
	local cmdname=config.cmds[config.selected.cmd].cmd
	widget.cactions.showbutton:SetChecked((config.button[cmdname] or {}).show)
	--TODO ggf. show macro name to be executed from config.button[cmdname].cmd
	if config.cmds[config.selected.cmd].delete then
		for t=1,5,1 do
			widget.cactions.tgt[t]:Hide()
		end	
		widget.cactions.say:Hide()
		widget.cactions.emo:Hide()
		for t=1,12,1 do
			widget.cactions.text[t]:SetText("")
		end
	end
	config.setup=false
end

function Me:ButtonShowChange()
	local cmdname=config.cmds[config.selected.cmd].cmd
	if not widget.cactions.showbutton:GetChecked() then config.button[cmdname].show=nil
	else
		-- TODO wahlweise auch cmd=macroname statt cmd=cmdname
		config.button[cmdname]={show=true,cmd=cmdname}
	end
	Me:InputChanged()
end

-- --------------------------------------------------------------------------------------
-- KEY PRESSED 
-- --------------------------------------------------------------------------------------
function Me:InputChanged(editfield,key)
	-- check for changes in cmds
	if config.snr==1 then
		config.changed=false
		if config.cmds[config.selected.cmd].delete then config.changed=true end
		if config.cmds[config.selected.cmd].list.option.notarget~=config.cmds[config.selected.cmd].original.option.notarget then config.changed=true end
		local react=widget.cactions.react:GetValue()
		local mute=widget.cactions.mute:GetValue()
		local option=config.cmds[config.selected.cmd].list.option
		if react==option.react.default then option.react[PLAYERNAME]=nil else option.react[PLAYERNAME]=react end
		if mute==option.mute.default then option.mute[PLAYERNAME]=nil else option.mute[PLAYERNAME]=mute end
		if option.react[PLAYERNAME]~=config.cmds[config.selected.cmd].original.option.react[PLAYERNAME] then config.changed=true end
		if option.mute[PLAYERNAME]~=config.cmds[config.selected.cmd].original.option.mute[PLAYERNAME] then config.changed=true end
		local cmdname=config.cmds[config.selected.cmd].cmd
		if (config.button[cmdname] or {}).cmd~=(dbpc.button[cmdname] or {}).cmd then config.changed=true end
		if (config.button[cmdname] or {}).show~=(dbpc.button[cmdname] or {}).show then config.changed=true end
		-- TODO check for new commands ... auch original muss dann mit "Leercmd" angepasst werden
		for t=1,12,1 do
			local nr=config.top.txt+t-1
			local entry=config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]
			local original=config.cmds[config.selected.cmd].original[config.selected.tgt][config.selected.es][nr]
			if editfield and t==editfield.selection and not entry then
				config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]={}
				config.cmds[config.selected.cmd].original[config.selected.tgt][config.selected.es][nr]={}
				widget.cactions.tselect[t]:SetChecked(true)
				config.changed=true
			end
			if entry and not original then config.changed=true -- should never happen
			elseif entry then
				if (entry.select and not original.select) or (entry.exclude and not original.exclude) then config.changed=true
				elseif entry.select and not Me:EqualXS(entry.select,original.select) then config.changed=true
				elseif entry.exclude and not Me:EqualsXS(entry.exclude,original.exclude) then config.changed=true
				end
				local text=mod.f:Trim(widget.cactions.text[t]:GetText())
				entry.text=text
				if text~=original.text then config.changed=true end
			end
		end
	-- check for changes in hesheit
	elseif config.snr==2 then
		local parse=mod.f:Split(editfield:GetName(),"_")
		local nr=tonumber(parse[#parse])+config.top-1
		local what=parse[#parse-1]
		local content=mod.f:Trim(editfield:GetText() or "")
		if not config.keys[nr] and content~="" then config.keys[nr]={key=nil,list={}, originallist={}} end
		if what=="Key" then config.keys[nr].key=content
		elseif what=="He" then config.keys[nr].list[1]=content
		elseif what=="She" then config.keys[nr].list[2]=content
		elseif what=="It" then config.keys[nr].list[3]=content
		end
		config.changed=false
		for nr=1,#config.keys,1 do
			local entry=config.keys[nr]
			if (entry.key or "")~=(entry.originalkey or "") then config.changed=true end
			for l=1,3,1 do
				if (entry.list[l] or "")~=(entry.originallist[l] or "") then config.changed=true end
			end
		end
	end
	if config.setup then config.changed=false end
	mod.core:SetUnsavedChanges(config.changed)
end
function Me:EqualsXS(tbl1,tbl2)
	local equal=true
	local check=mod.f:CopyTable(tbl2)
	for key,data in pairs(tbl1) do
		if check[key]==nil or data~=tbl2[key] then equal=false end
		check[key]=nil
	end
	for key,data in pairs(check) do
		if data~=nil then equal=false end
	end
	return equal
end

-- --------------------------------------------------------------------------------------
-- SCROLL
-- --------------------------------------------------------------------------------------
function Me:ScrollUpKeys() Me:ScrollKeys(-1) end
function Me:ScrollDownKeys() Me:ScrollKeys(1) end
function Me:ScrollKeys(by)
	config.top=math.max(1,math.min(#config.keys-18,config.top+by))
	if config.top==1 then widget.ckeys.up:Disable() else widget.ckeys.up:Enable() end
	if config.top>=#config.keys-18 then widget.ckeys.down:Disable() else widget.ckeys.down:Enable() end
	for nr=1,20,1 do
		local entry=config.keys[config.top+nr-1] or {list={}}
		widget.ckeys.key[nr]:SetText(entry.key or "")
		widget.ckeys.he[nr]:SetText(entry.list[1] or "")
		widget.ckeys.she[nr]:SetText(entry.list[2] or "")
		widget.ckeys.it[nr]:SetText(entry.list[3] or "")
		if config.top+nr-1>#config.keys+1 then
			widget.ckeys.key[nr]:Hide()
			widget.ckeys.he[nr]:Hide()
			widget.ckeys.she[nr]:Hide()
			widget.ckeys.it[nr]:Hide()
		else
			widget.ckeys.key[nr]:Show()
			widget.ckeys.he[nr]:Show()
			widget.ckeys.she[nr]:Show()
			widget.ckeys.it[nr]:Show()
		end
	end
end

-- --------------------------------------------------------------------------------------
-- SAVE CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	if config.snr==1 then
		local cmd=config.cmds[config.selected.cmd].cmd
		local list={}
		for n,entry in pairs(config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es]) do
			if entry.text and entry.text~="" then list[1+#list]=entry end
		end
		db.emotor.cmd[cmd][config.selected.tgt][config.selected.es]=list		
		db.emotor.cmd[cmd].option=mod.f:CopyTable(config.cmds[config.selected.cmd].list.option)
		-- TODO cmd=cmd wahlweise auch als cmd=macroname in nächster Zeile
		dbpc.button[cmd]={cmd=cmd,show=widget.cactions.showbutton:GetChecked()}
		if config.cmds[config.selected.cmd].delete then
			db.emotor.cmd[cmd]=nil
			dbpc.button[cmd]=nil
		end
	elseif config.snr==2 then
		local hesheit={}
		for n=1,#config.keys,1 do
			if (config.keys[n].key or "")~="" then
				local list=config.keys[n].list
				hesheit[config.keys[n].key]={[1]=list[1],[2]=list[2],[3]=list[3]}
			end
		end
		db.emotor.hesheit=hesheit
	end
	Me:ShowButtons()
	Me:StartConfig(frame)
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) 
	Me:StartConfig(frame)
	return true 
end